<div style="width:100px; float:left; margin-right:10px; line-height:1.5em;">
    <h1>Folder Options</h1>
    <ul class="ls_menu">
        <li><a href="folders.php" class="special">All folders</a></li>
        <li><a href="folders.php?action=create" class="special">Create new folder</a></li>
	<!--<li><a href="folders.php?action=cgallery" class="special">Create gallery</a></li>-->
    </ul>
</div>

<div style="width:480px; float: right;">

    <?php /* Create a new folder */ if ( $action == 'create' ) : ?>

    <h1>Create folder</h1>
    <form method="post" action="folders.php?action=create">
        <input type="hidden" name="action" value="create" />
        <input type="hidden" name="task" value="create" />
        <p>The folder name must contain only alphanumeric (letters and numbers) characters.</p>
        <?php /* Errors will be printed here */ if ( isset ( $error ) ) print $error; ?>
        <table cellspacing="1" cellpadding="2" border="0" style="margin-top: 10px;">
            <tr>
                <td>Create new folder in</td>
                <td>
                    <select name="create_in">
                        <option value="">Main Folder</option>
                        <?php /* Loop through list of folders */ reset ( $user_folders ); while ( list ( $i, $folder ) = each ( $user_folders ) ) : $folder['spaces'] = str_repeat ( '&nbsp;&nbsp;&nbsp;', $folder['level'] ); ?>
                        <option value="<?=$folder['path']?>" <?=$folder['is_selected'] ? 'selected="selected"' : ''?> >
			    <?=$folder['spaces']?><?=str_slice($folder['name'],30)?>
			</option>
                        <?php /* End loop */ endwhile; ?>
                    </select>
                </td>
            </tr>
            <tr>
                <td>New folder name</td>
                <td>
                    <input type="text" name="new_folder_name" value="<?=$folder_name?>" size="50" maxlength="50" />
                </td>
            </tr>
	    <tr>
		<td>Description</td>
		<td><input type="text" name="folder_description" value="" size="50" maxlength="200" /> <span class="help" onclick="help('Enter a short description of the folder. Ex: John\'s birthday party.');">What's this?</span></td>
	    </tr>
	    <tr>
		<td></td>
		<td>
		    <input type="checkbox" name="folder_public" id="folder_public" value="1" class="chkbox" />
		    <label for="folder_public">Set this folder as a public folder.</label>
		</td>
	    </tr>
            <tr>
                <td></td>
                <td><input type="submit" value="Create" class="blue_button"  />&nbsp;<input type="button" value="Cancel" class="blue_button"  onclick="go('folders.php');" /></td>
            </tr>
        </table>
    </form>

    <?php /* Rename */ elseif ( $action == 'edit' ) : ?>

    <h1>Edit folder properties</h1>

    <?php /* Errors will be printed here */ if ( isset ( $error ) ) print $error; ?>

    <form method="post" action="folders.php?action=edit">
        <input type="hidden" name="action" value="rename" />
        <input type="hidden" name="task" value="edit" />
        <input type="hidden" name="folder_path" value="<?=$folder_path?>" />

	<table cellspacing="3" cellpadding="1" border="0">
	    <tr>
		<td style="width:80px;">Folder name:</td>
		<td><input type="text" name="folder_name" value="<?=$folder_name?>" size="50" maxlength="50" /></td>
	    </tr>
	    <tr>
		<td>Description:</td>
		<td><input type="text" name="folder_description" value="<?=$folder_description?>" size="50" maxlength="200" /></td>
	    </tr>
	    <tr>
		<td class="tt">Options:</td>
		<td style="line-height:1.6em;">
		    <input type="checkbox" class="chkbox" name="folder_public" value="1" id="folder_public" <?=$folder_public ? 'checked="checked"' : '' ?> /> <label for="folder_public">Make this folder public (allow other users to browse its contents).</label><br />
		    <input type="checkbox" class="chkbox" name="folder_delete" value="1" id="delete_folder" onclick="return confirm('Are you sure you want to delete this folder and all contents inside it?');" /> <label for="delete_folder">Delete this folder and all contents inside this folder.</label>
		</td>
	    </tr>
	    <tr>
		<td></td>
		<td>
		    <input type="submit" value="Apply" class="blue_button" />&nbsp;
		    <input type="button" value="Cancel" class="blue_button" onclick="go('folders.php');" />
		</td>
	    </tr>
	</table>
    </form>

    <?php /* Create gallery */  elseif ( $action == 'cgallery' ) : ?>

    <h1>Create a gallery</h1>
    <p class="p1">
	This tool will turn one of your folders into a gallery which can be viewed
	through the Browse page. The folder you select will be marked as Public and new folder called "thumbnails" will be created. Delete this folder ONLY if you
	do not want the folder to act as a gallery. If you add new images to the select folder, simply run this tool again and select the same folder. Thumbnails
	will be created for the new images.
    </p>

    <p>
	 Creating thumbnails may take a while, please wait. You will notified once the operation completes.
    </p>

    <?php /* Errors will be printed here */ if ( isset ( $error ) ) print $error; ?>

    <form method="post" action="folders.php?action=cgallery">
	<input type="hidden" name="task" value="cgallery" />
        <table cellspacing="1" cellpadding="2" border="0" style="margin-top:5px;">
	    <tr>
                <td>Select a folder</td>
                <td>
                    <select name="create_in">
                        <?php /* Loop through list of folders */ reset ( $user_folders ); while ( list ( $i, $folder ) = each ( $user_folders ) ) : $folder['spaces'] = str_repeat ( '&nbsp;&nbsp;&nbsp;', $folder['level'] ); ?>
                        <option value="<?=$folder['path']?>" <?=$folder['is_selected'] ? 'selected="selected"' : ''?> >
			    <?=$folder['spaces']?><?=str_slice($folder['name'],30)?>
			</option>
                        <?php /* End loop */ endwhile; ?>
                    </select>
		    <input type="submit" value="Create" class="blue_button" />
                </td>
            </tr>
        </table>
    </form>

    <?php /* No task, just list folders */ else: ?>
    <h1>Your folders</h1>

    <p class="p1">
	<strong class="s2">Set all folders as:</strong> &nbsp;<a href="folders.php?action=setpublic&amp;public=yes" class="special">Public</a> - <a href="folders.php?action=setpublic&amp;public=no" class="special">Private</a>
    </p>

    <table id="tbl1" style="width:100%;color:#404040;" cellpadding="3" cellspacing="0" border="0">
	<tr style="line-height:1.6em;">
	    <td style="width:16px;"><img src="templates/default/images/folder4.gif" alt="Private" class="img1" /></td>
            <td style="width:310px;"><a href="<?=$main_folder['folder_url']?>" class="special">Main Folder</a></td>
            <td class="ct"><?=$main_folder['files'] ? $main_folder['files'] . ' files':'Empty'?></td>
            <td class="ct"><?=$main_folder['size']?></td>
            <td></td>
        </tr>
        <?php /* Loop through folders and list them */ reset ( $user_folders ); while ( list ( $i, $folder ) = each ( $user_folders ) ) : $folder['spaces'] = str_repeat ( '&nbsp; &nbsp; ', $folder['level'] ); ?>
        <tr>
	    <td><?=$folder['is_public']?'<img src="templates/default/images/folder3.gif" alt="Public" class="img1"/>':'<img src="templates/default/images/folder4.gif" alt="Private" class="img1" />'?></td>
            <td><?=$folder['spaces']?><a href="<?=$folder['folder_url']?>" class="special"><?=$folder['name']?></a><?=$folder['description'] != '' ? '&nbsp; <span class="small">' . substr ( $folder['description'], 0, 25 ) . '...</span>' : '' ?></td>
	    <td class="ct"><?=$folder['files'] ? $folder['files'] . ' files' : 'empty' ?></td>
            <td class="ct"><?=$folder['size'] != '0.0B' ? $folder['size'] : 'empty' ?></td>
            <td class="ct"><a href="<?=$folder['edit_url']?>"><img src="templates/default/images/b_edit.gif" alt="" /></a></td>
        </tr>
        <?php endwhile; ?>
	<tr>
	    <td colspan="5"><img src="templates/default/images/folder4.gif" alt="Public" class="img1"/> Private folder - <img src="templates/default/images/folder3.gif" alt="Public" class="img1"/> Public folder</td>
	</tr>
    </table>
    <?php endif; ?>
</div>
<div class="spacer"><!-- --></div>
<script type="text/javascript">
    alternateRowColor(getObj('tbl1'),'tr','#fafafa','#ffffff');
</script>